{-|
Description:    

Copyright:      (c) 2020 Samuel May
License:        MPL-2.0
Maintainer:     ag.eitilt@gmail.com

Stability:      experimental
Portability:    portable
-}
module Main where


import qualified Control.Monad as N

import qualified Hedgehog as H

import qualified System.Exit as E

import qualified Test.Willow.Property.DOM as DOM
import qualified Test.Willow.Property.Parser as Parser


main :: IO ()
main = do
    laws <- sequence
        [ DOM.laws
        ]
    results <- mapM H.checkParallel $
        DOM.tests
        ++ Parser.tests
    
    N.unless (and $ laws ++ results) E.exitFailure
